;;; -*- Mode: Lisp; Package: STELLA; Syntax: COMMON-LISP; Base: 10 -*-

#|--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------|#

(CL:IN-PACKAGE "STELLA")

;;; Auxiliary variables:

(CL:DEFVAR SYM-STREAMS-STELLA-EOL NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-PRINT-STREAM NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STANDARD-OUTPUT NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-PRINT NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-PRINT-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-INFORM NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-INFORM-EXPANDER NULL)
(CL:DEFVAR KWD-STREAMS-COMMON-LISP NULL)
(CL:DEFVAR KWD-STREAMS-WARN NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STANDARD-WARNING NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WARN NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WARN-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-NULL NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STELLA-EXCEPTION NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-STRING-WRAPPER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-EXCEPTION NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-NEW NULL)
(CL:DEFVAR KWD-STREAMS-MESSAGE NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-LET NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-OUTPUT-STRING-STREAM NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-THE-STRING NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-ERROR-EXPANDER NULL)
(CL:DEFVAR KWD-STREAMS-JAVA NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-ERROR_MESSAGE_ NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-VERBATIM NULL)
(CL:DEFVAR KWD-STREAMS-CONTINUABLE-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-CONTINUABLE-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-CONTINUABLE-ERROR-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-READ-EXCEPTION NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-READ-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-READ-ERROR-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-DE-UGLIFY-PARSE-TREE NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SPECIAL NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-*PRINTREADABLY?* NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-TRUE NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-UNLESS NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SUPPRESS-WARNINGS? NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-PRINT-ERROR-CONTEXT NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STANDARD-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-ERROR-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-WARNING NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-INFORM NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-INFORM-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-WARN NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WALK-WARN-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WHEN NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-NOT NULL)
(CL:DEFVAR KWD-STREAMS-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SAFETY NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SAFETY-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-*EVALUATIONTREE* NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-DEFINED? NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-*EVALUATIONPARENTTREE* NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-EVALUATION-EXCEPTION NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-EVALUATION-ERROR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-EVALUATION-ERROR-EXPANDER NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-LITERAL-WRAPPER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STRINGIFY NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-VRLET NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STRING NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SETQ NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-CONCATENATE NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-MESSAGE-TO-STRING NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-MESSAGE-TO-STRING-EXPANDER NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-OBJECT NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-PROGN NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-SUBSEQUENCE NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-POSITION NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WITH-HTML-TAG NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WITH-HTML-TAG-EXPANDER NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WITH-XML-TAG NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-WITH-XML-TAG-EXPANDER NULL)
(CL:DEFVAR KWD-STREAMS-CLOSED NULL)
(CL:DEFVAR KWD-STREAMS-OPEN NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-FILE-INPUT-STREAM NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-FILE-OUTPUT-STREAM NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-INPUT-STREAM NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-OUTPUT-STREAM NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-THE-STREAM NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-S-EXPRESSION-ITERATOR NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-LINE-ITERATOR NULL)
(CL:DEFVAR SGT-STREAMS-STELLA-CHARACTER-ITERATOR NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-STARTUP-STREAMS NULL)
(CL:DEFVAR SYM-STREAMS-STELLA-METHOD-STARTUP-CLASSNAME NULL)

;;; Forward declarations:

(CL:DECLAIM
 (CL:SPECIAL *STELLA-MODULE* *MODULE* NULL-CHARACTER *SAFETY*
  *TRANSLATOROUTPUTLANGUAGE*))

;;; (DEFGLOBAL EOL ...)

(CL:DEFVAR EOL NULL
  "Generates a newline character when passed to a stream.")

;;; (DEFGLOBAL EOL-STRING ...)

(CL:DEFVAR EOL-STRING "
"
  "A string constant containing the character sequence
necessary to generate a newline.")
(CL:DECLAIM (CL:TYPE CL:SIMPLE-STRING EOL-STRING))

;;; (DEFGLOBAL STANDARD-INPUT ...)

(CL:DEFVAR STANDARD-INPUT NULL
  "Denotes the standard input stream for the host language.")

;;; (DEFGLOBAL STANDARD-OUTPUT ...)

(CL:DEFVAR STANDARD-OUTPUT NULL
  "Denotes the standard output stream for the host language.")

;;; (DEFGLOBAL STANDARD-WARNING ...)

(CL:DEFVAR STANDARD-WARNING NULL
  "Denotes the standard warning stream for the host language.")

;;; (DEFGLOBAL STANDARD-ERROR ...)

(CL:DEFVAR STANDARD-ERROR NULL
  "Denotes the standard error stream for the host language.")

;;; (DEFGLOBAL SINGLE-QUOTE-STRING ...)

(CL:DEFVAR SINGLE-QUOTE-STRING NULL
  "Holds a string containing the single quote character.")

;;; (DEFGLOBAL SINGLE-BQUOTE-STRING ...)

(CL:DEFVAR SINGLE-BQUOTE-STRING NULL
  "Holds a string containing the single backquote character.")

;;; (DEFUN (FORMAT-MESSAGE-ARGUMENTS CONS) ...)

(CL:DEFUN FORMAT-MESSAGE-ARGUMENTS (MESSAGEARGUMENTSTREE TRAILINGEOL?)
  (CL:LET* ((AUGMENTEDARGUMENTS NIL))
   (CL:LET* ((ITEM NULL) (ITER-000 MESSAGEARGUMENTSTREE))
    (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-000 NIL)) DO
     (CL:PROGN (CL:SETQ ITEM (%%VALUE ITER-000))
      (CL:SETQ ITER-000 (%%REST ITER-000)))
     (CL:COND
      ((CL:OR (STRING? ITEM) (CL:EQ ITEM EOL))
       (CL:SETQ AUGMENTEDARGUMENTS (CONS ITEM AUGMENTEDARGUMENTS)))
      (CL:T
       (CL:SETQ AUGMENTEDARGUMENTS
        (CONS SINGLE-BQUOTE-STRING AUGMENTEDARGUMENTS))
       (CL:SETQ AUGMENTEDARGUMENTS (CONS ITEM AUGMENTEDARGUMENTS))
       (CL:SETQ AUGMENTEDARGUMENTS
        (CONS SINGLE-QUOTE-STRING AUGMENTEDARGUMENTS))))))
   (CL:WHEN TRAILINGEOL?
    (CL:SETQ AUGMENTEDARGUMENTS (CONS EOL AUGMENTEDARGUMENTS)))
   (CL:RETURN-FROM FORMAT-MESSAGE-ARGUMENTS (REVERSE AUGMENTEDARGUMENTS))))

;;; (DEFMACRO PRINT ...)

(CL:DEFUN PRINT-EXPANDER (BODY)
  "Print arguments to the standard output stream."
  (CL:RETURN-FROM PRINT-EXPANDER
   (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-OUTPUT
    (CONCATENATE BODY NIL))))

;;; (DEFMACRO INFORM ...)

(CL:DEFUN INFORM-EXPANDER (BODY)
  "Print informative message, placing non-string arguments in quotes,
and terminating with a newline."
  (CL:SETQ BODY (FORMAT-MESSAGE-ARGUMENTS BODY TRUE))
  (CL:RETURN-FROM INFORM-EXPANDER
   (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-OUTPUT
    (CONCATENATE BODY NIL))))

;;; (DEFMACRO WARN ...)

(CL:DEFUN WARN-EXPANDER (BODY)
  "Signal warning message, placing non-string arguments in quotes."
  (CL:SETQ BODY (FORMAT-MESSAGE-ARGUMENTS BODY FALSE))
  (CL:IF (CL:EQ *TRANSLATOROUTPUTLANGUAGE* KWD-STREAMS-COMMON-LISP)
   (CL:RETURN-FROM WARN-EXPANDER
    (LIST* SYM-STREAMS-STELLA-PRINT-STREAM KWD-STREAMS-WARN
     (CONCATENATE BODY NIL)))
   (CL:RETURN-FROM WARN-EXPANDER
    (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-WARNING
     (WRAP-STRING "Warning: ")
     (CONCATENATE BODY (CONS SYM-STREAMS-STELLA-EOL NIL))))))

;;; (DEFMACRO SIGNAL ...)

(CL:DEFUN SIGNAL-EXPANDER (TYPE BODY)
  "Signal error message, placing non-string arguments in quotes."
  (CL:WHEN (CL:EQ TYPE SYM-STREAMS-STELLA-NULL)
   (CL:SETQ TYPE SYM-STREAMS-STELLA-STELLA-EXCEPTION))
  (CL:IF
   (CL:AND (CL:= (LENGTH BODY) 1)
    (ISA? (%%VALUE BODY) SGT-STREAMS-STELLA-STRING-WRAPPER))
   (CL:RETURN-FROM SIGNAL-EXPANDER
    (LIST* SYM-STREAMS-STELLA-SIGNAL-EXCEPTION
     (LIST* SYM-STREAMS-STELLA-NEW TYPE
      (LIST* KWD-STREAMS-MESSAGE (%%VALUE BODY) NIL))
     NIL))
   (CL:LET* ((STREAMVAR (LOCAL-GENSYM "STREAM")))
    (CL:RETURN-FROM SIGNAL-EXPANDER
     (LIST* SYM-STREAMS-STELLA-LET
      (CONS
       (CONS STREAMVAR
        (CONS
         (LIST* SYM-STREAMS-STELLA-NEW SYM-STREAMS-STELLA-OUTPUT-STRING-STREAM
          NIL)
         NIL))
       NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
       (CONCATENATE (FORMAT-MESSAGE-ARGUMENTS BODY FALSE) NIL))
      (LIST* SYM-STREAMS-STELLA-SIGNAL-EXCEPTION
       (LIST* SYM-STREAMS-STELLA-NEW TYPE
        (LIST* KWD-STREAMS-MESSAGE
         (LIST* SYM-STREAMS-STELLA-THE-STRING STREAMVAR NIL) NIL))
       NIL)
      NIL)))))

;;; (DEFMACRO ERROR ...)

(CL:DEFUN ERROR-EXPANDER (BODY)
  "Signal error message, placing non-string arguments in quotes."
  (CL:RETURN-FROM ERROR-EXPANDER
   (LIST* SYM-STREAMS-STELLA-SIGNAL SYM-STREAMS-STELLA-STELLA-EXCEPTION
    (CONCATENATE BODY NIL))))

;;; (DEFMACRO CONTINUABLE-ERROR ...)

(CL:DEFUN CONTINUABLE-ERROR-EXPANDER (BODY)
  "Signal error message, placing non-string arguments in quotes."
  (CL:SETQ BODY (FORMAT-MESSAGE-ARGUMENTS BODY FALSE))
  (CL:IF (CL:EQ *TRANSLATOROUTPUTLANGUAGE* KWD-STREAMS-JAVA)
   (CL:IF
    (CL:AND (CL:= (LENGTH BODY) 1)
     (ISA? (%%VALUE BODY) SGT-STREAMS-STELLA-STRING-WRAPPER))
    (CL:RETURN-FROM CONTINUABLE-ERROR-EXPANDER
     (LIST* SYM-STREAMS-STELLA-LET
      (CONS
       (LIST* SYM-STREAMS-STELLA-ERROR_MESSAGE_
        (WRAP-STRING (%WRAPPER-VALUE (%%VALUE BODY))) NIL)
       NIL)
      (LIST* SYM-STREAMS-STELLA-VERBATIM KWD-STREAMS-JAVA
       (WRAP-STRING "Native.continuableError(error_message_)") NIL)
      NIL))
    (CL:LET* ((STREAMVAR (LOCAL-GENSYM "STREAM")))
     (CL:RETURN-FROM CONTINUABLE-ERROR-EXPANDER
      (LIST* SYM-STREAMS-STELLA-LET
       (CONS
        (CONS STREAMVAR
         (CONS
          (LIST* SYM-STREAMS-STELLA-NEW SYM-STREAMS-STELLA-OUTPUT-STRING-STREAM
           NIL)
          NIL))
        NIL)
       (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
        (CONCATENATE (FORMAT-MESSAGE-ARGUMENTS BODY FALSE) NIL))
       (LIST* SYM-STREAMS-STELLA-LET
        (CONS
         (LIST* SYM-STREAMS-STELLA-ERROR_MESSAGE_
          (LIST* SYM-STREAMS-STELLA-THE-STRING STREAMVAR NIL) NIL)
         NIL)
        (LIST* SYM-STREAMS-STELLA-VERBATIM KWD-STREAMS-JAVA
         (WRAP-STRING "Native.continuableError(error_message_)") NIL)
        NIL)
       NIL))))
   (CL:RETURN-FROM CONTINUABLE-ERROR-EXPANDER
    (LIST* SYM-STREAMS-STELLA-PRINT-STREAM KWD-STREAMS-CONTINUABLE-ERROR
     (CONCATENATE BODY NIL)))))

;;; (DEFMACRO SIGNAL-READ-ERROR ...)

(CL:DEFUN SIGNAL-READ-ERROR-EXPANDER (BODY)
  "Specialized version of `signal' that throws a READ-EXCEPTION."
  (CL:RETURN-FROM SIGNAL-READ-ERROR-EXPANDER
   (LIST* SYM-STREAMS-STELLA-SIGNAL SYM-STREAMS-STELLA-READ-EXCEPTION
    (CONCATENATE BODY NIL))))

;;; (DEFUN (FORMAT-WALK-MESSAGE-ARGUMENTS CONS) ...)

(CL:DEFUN FORMAT-WALK-MESSAGE-ARGUMENTS (MESSAGEARGUMENTSTREE)
  (CL:LET* ((IT (ALLOCATE-ITERATOR MESSAGEARGUMENTSTREE)))
   (CL:LOOP WHILE (NEXT? IT) DO
    (CL:LET* ((ITEM (%VALUE IT)))
     (CL:COND
      ((SUBTYPE-OF-SYMBOL? (SAFE-PRIMARY-TYPE ITEM))
       (CL:PROGN
        (CL:WHEN (CL:NOT (CL:EQ ITEM EOL))
         (VALUE-SETTER IT
          (LIST* SYM-STREAMS-STELLA-DE-UGLIFY-PARSE-TREE ITEM NIL)))))
      (CL:T)))))
  (CL:RETURN-FROM FORMAT-WALK-MESSAGE-ARGUMENTS MESSAGEARGUMENTSTREE))

;;; (DEFMACRO WALK-ERROR ...)

(CL:DEFUN WALK-ERROR-EXPANDER (BODY)
  (CL:LET*
   ((MESSAGEARGUMENTS
     (FORMAT-MESSAGE-ARGUMENTS (FORMAT-WALK-MESSAGE-ARGUMENTS BODY) FALSE)))
   (CL:RETURN-FROM WALK-ERROR-EXPANDER
    (LIST* SYM-STREAMS-STELLA-SPECIAL
     (CONS
      (LIST* SYM-STREAMS-STELLA-*PRINTREADABLY?* SYM-STREAMS-STELLA-TRUE NIL)
      NIL)
     (CONS SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-ERROR NIL)
     (LIST* SYM-STREAMS-STELLA-UNLESS
      (CONS SYM-STREAMS-STELLA-SUPPRESS-WARNINGS? NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-ERROR-CONTEXT (WRAP-STRING ">> ERROR: ")
       SYM-STREAMS-STELLA-STANDARD-ERROR NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-ERROR
       SYM-STREAMS-STELLA-EOL (WRAP-STRING " ")
       (CONCATENATE MESSAGEARGUMENTS
        (LIST* (WRAP-STRING ".") SYM-STREAMS-STELLA-EOL NIL)))
      NIL)
     NIL))))

;;; (DEFMACRO WALK-INFORM ...)

(CL:DEFUN WALK-INFORM-EXPANDER (BODY)
  (CL:LET*
   ((MESSAGEARGUMENTS
     (FORMAT-MESSAGE-ARGUMENTS (FORMAT-WALK-MESSAGE-ARGUMENTS BODY) FALSE)))
   (CL:RETURN-FROM WALK-INFORM-EXPANDER
    (LIST* SYM-STREAMS-STELLA-SPECIAL
     (CONS
      (LIST* SYM-STREAMS-STELLA-*PRINTREADABLY?* SYM-STREAMS-STELLA-TRUE NIL)
      NIL)
     (CONS SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-WARNING NIL)
     (LIST* SYM-STREAMS-STELLA-UNLESS
      (CONS SYM-STREAMS-STELLA-SUPPRESS-WARNINGS? NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-ERROR-CONTEXT (WRAP-STRING ">> WARNING: ")
       SYM-STREAMS-STELLA-STANDARD-OUTPUT NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-OUTPUT
       SYM-STREAMS-STELLA-EOL (WRAP-STRING " ")
       (CONCATENATE MESSAGEARGUMENTS
        (LIST* (WRAP-STRING ".") SYM-STREAMS-STELLA-EOL NIL)))
      NIL)
     NIL))))

;;; (DEFMACRO WALK-WARN ...)

(CL:DEFUN WALK-WARN-EXPANDER (BODY)
  (CL:LET*
   ((MESSAGEARGUMENTS
     (FORMAT-MESSAGE-ARGUMENTS (FORMAT-WALK-MESSAGE-ARGUMENTS BODY) FALSE)))
   (CL:RETURN-FROM WALK-WARN-EXPANDER
    (LIST* SYM-STREAMS-STELLA-SPECIAL
     (CONS
      (LIST* SYM-STREAMS-STELLA-*PRINTREADABLY?* SYM-STREAMS-STELLA-TRUE NIL)
      NIL)
     (CONS SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-WARNING NIL)
     (LIST* SYM-STREAMS-STELLA-UNLESS
      (CONS SYM-STREAMS-STELLA-SUPPRESS-WARNINGS? NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-ERROR-CONTEXT (WRAP-STRING ">> WARNING: ")
       SYM-STREAMS-STELLA-STANDARD-WARNING NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-STREAM SYM-STREAMS-STELLA-STANDARD-WARNING
       SYM-STREAMS-STELLA-EOL (WRAP-STRING " ")
       (CONCATENATE MESSAGEARGUMENTS
        (LIST* (WRAP-STRING ".") SYM-STREAMS-STELLA-EOL NIL)))
      NIL)
     NIL))))

;;; (DEFMACRO SAFETY ...)

(CL:DEFUN SAFETY-EXPANDER (LEVEL TEST BODY)
  "Signal warning message, placing non-string arguments in quotes."
  (CL:WHEN (CL:> (%WRAPPER-VALUE LEVEL) *SAFETY*)
   (CL:RETURN-FROM SAFETY-EXPANDER NULL))
  (CL:SETQ BODY (FORMAT-MESSAGE-ARGUMENTS BODY FALSE))
  (CL:RETURN-FROM SAFETY-EXPANDER
   (LIST* SYM-STREAMS-STELLA-WHEN (LIST* SYM-STREAMS-STELLA-NOT TEST NIL)
    (LIST* SYM-STREAMS-STELLA-PRINT-STREAM KWD-STREAMS-ERROR
     (WRAP-STRING "Safety violation: ") (CONCATENATE BODY NIL))
    NIL)))

;;; (DEFMACRO EVALUATION-ERROR ...)

(CL:DEFUN EVALUATION-ERROR-EXPANDER (BODY)
  (CL:LET* ((STREAMVAR (LOCAL-GENSYM "STREAM")))
   (CL:RETURN-FROM EVALUATION-ERROR-EXPANDER
    (LIST* SYM-STREAMS-STELLA-LET
     (CONS
      (CONS STREAMVAR
       (CONS
        (LIST* SYM-STREAMS-STELLA-NEW SYM-STREAMS-STELLA-OUTPUT-STRING-STREAM
         NIL)
        NIL))
      NIL)
     (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
      (LIST* (WRAP-STRING "While evaluating '")
       SYM-STREAMS-STELLA-*EVALUATIONTREE* NIL))
     (LIST* SYM-STREAMS-STELLA-WHEN
      (LIST* SYM-STREAMS-STELLA-DEFINED?
       SYM-STREAMS-STELLA-*EVALUATIONPARENTTREE* NIL)
      (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
       (LIST* SYM-STREAMS-STELLA-EOL (WRAP-STRING "' inside '")
        SYM-STREAMS-STELLA-*EVALUATIONPARENTTREE* NIL))
      NIL)
     (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
      (LIST* (WRAP-STRING "':") SYM-STREAMS-STELLA-EOL NIL))
     (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAMVAR
      (CONCATENATE (FORMAT-MESSAGE-ARGUMENTS BODY FALSE) NIL))
     (LIST* SYM-STREAMS-STELLA-SIGNAL-EXCEPTION
      (LIST* SYM-STREAMS-STELLA-NEW SYM-STREAMS-STELLA-EVALUATION-EXCEPTION
       KWD-STREAMS-MESSAGE (LIST* SYM-STREAMS-STELLA-THE-STRING STREAMVAR NIL)
       NIL)
      NIL)
     NIL))))

;;; (DEFUN (FORMAT-STRING-MESSAGE-ARGUMENTS CONS) ...)

(CL:DEFUN FORMAT-STRING-MESSAGE-ARGUMENTS (MESSAGEARGUMENTS TRAILINGEOL?)
  (CL:LET*
   ((FORMATTEDARGUMENTS
     (FORMAT-MESSAGE-ARGUMENTS MESSAGEARGUMENTS TRAILINGEOL?)))
   (CL:LET* ((IT (ALLOCATE-ITERATOR FORMATTEDARGUMENTS)))
    (CL:LOOP WHILE (NEXT? IT) DO
     (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE (%VALUE IT))))
      (CL:COND ((SUBTYPE-OF-STRING? TEST-VALUE-000))
       ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-LITERAL-WRAPPER)
        (VALUE-SETTER IT (WRAP-STRING (STRINGIFY (%VALUE IT)))))
       (CL:T
        (CL:IF (CL:EQ (%VALUE IT) SYM-STREAMS-STELLA-EOL)
         (VALUE-SETTER IT (WRAP-STRING EOL-STRING))
         (VALUE-SETTER IT
          (LIST* SYM-STREAMS-STELLA-STRINGIFY (%VALUE IT) NIL))))))))
   (CL:RETURN-FROM FORMAT-STRING-MESSAGE-ARGUMENTS FORMATTEDARGUMENTS)))

;;; (DEFMACRO MESSAGE-TO-STRING ...)

(CL:DEFUN MESSAGE-TO-STRING-EXPANDER (BODY)
  (CL:LET*
   ((MESSAGEARGUMENTS (FORMAT-STRING-MESSAGE-ARGUMENTS BODY FALSE))
    (MESSAGEVAR (LOCAL-GENSYM "MESSAGE")))
   (CL:RETURN-FROM MESSAGE-TO-STRING-EXPANDER
    (LIST* SYM-STREAMS-STELLA-VRLET
     (CONS
      (CONS MESSAGEVAR
       (LIST* SYM-STREAMS-STELLA-STRING SYM-STREAMS-STELLA-NULL NIL))
      NIL)
     (LIST* SYM-STREAMS-STELLA-SPECIAL
      (CONS
       (LIST* SYM-STREAMS-STELLA-*PRINTREADABLY?* SYM-STREAMS-STELLA-TRUE NIL)
       NIL)
      (LIST* SYM-STREAMS-STELLA-SETQ MESSAGEVAR
       (CONS
        (CONS SYM-STREAMS-STELLA-CONCATENATE (CONCATENATE MESSAGEARGUMENTS NIL))
        NIL))
      NIL)
     MESSAGEVAR NIL))))

;;; (DEFUN (EXPAND-MARKUP-TAG-FUNCTION CONS) ...)

(CL:DEFUN EXPAND-MARKUP-TAG-FUNCTION (TAG-AND-STREAM BODY XML?)
  (CL:LET*
   ((TAG (%%VALUE TAG-AND-STREAM)) (TAGVAR NULL) (TAGVALUE STELLA::NULL-STRING)
    (STREAM (%%VALUE (%%REST TAG-AND-STREAM)))
    (EOLARGUMENT (%%VALUE (%%REST (%%REST TAG-AND-STREAM))))
    (EOL?
     (CL:AND (CL:NOT (CL:EQ EOLARGUMENT NULL))
      (COERCE-WRAPPED-BOOLEAN-TO-BOOLEAN (COERCE-TO-BOOLEAN EOLARGUMENT)))))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING TAGVALUE))
   (CL:IF (CL:EQ BODY NIL)
    (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE TAG)))
     (CL:COND
      ((SUBTYPE-OF-STRING? TEST-VALUE-000)
       (CL:PROGN
        (CL:IF EOL?
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
           (CONS
            (WRAP-STRING
             (CONCATENATE "<" (%WRAPPER-VALUE TAG) (CL:IF XML? "/>" ">")))
            (CONS SYM-STREAMS-STELLA-EOL NIL))))
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
           (CONS
            (WRAP-STRING
             (CONCATENATE "<" (%WRAPPER-VALUE TAG) (CL:IF XML? "/>" ">")))
            NIL))))))
      ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-OBJECT)
       (CL:PROGN
        (CL:IF EOL?
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
           (LIST* (WRAP-STRING "<") TAG
            (CONS (CL:IF XML? (WRAP-STRING "/>") (WRAP-STRING ">"))
             (CONS SYM-STREAMS-STELLA-EOL NIL)))))
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
           (LIST* (WRAP-STRING "<") TAG
            (CONS (CL:IF XML? (WRAP-STRING "/>") (WRAP-STRING ">")) NIL)))))))
      (CL:T
       (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
        (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
         "' is not a valid case option")
        (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))
    (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE TAG)))
     (CL:COND
      ((SUBTYPE-OF-STRING? TEST-VALUE-001)
       (CL:PROGN (CL:SETQ TAGVALUE (%WRAPPER-VALUE TAG))
        (CL:IF EOL?
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PROGN
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (CONS (WRAP-STRING (CONCATENATE "<" TAGVALUE ">")) NIL))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (CONS
               (WRAP-STRING
                (CONCATENATE "</"
                 (SUBSEQUENCE TAGVALUE 0 (POSITION TAGVALUE #\  0)) ">"))
               (CONS SYM-STREAMS-STELLA-EOL NIL)))
             NIL))))
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PROGN
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (CONS (WRAP-STRING (CONCATENATE "<" TAGVALUE ">")) NIL))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (CONS
               (WRAP-STRING
                (CONCATENATE "</"
                 (SUBSEQUENCE TAGVALUE 0 (POSITION TAGVALUE #\  0)) ">"))
               NIL))
             NIL)))))))
      ((SUBTYPE-OF-SYMBOL? TEST-VALUE-001)
       (CL:PROGN
        (CL:IF EOL?
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PROGN
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (LIST* (WRAP-STRING "<") TAG (CONS (WRAP-STRING ">") NIL)))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (LIST* (WRAP-STRING "</")
               (LIST* SYM-STREAMS-STELLA-SUBSEQUENCE TAG
                (LIST* (WRAP-INTEGER 0)
                 (LIST* SYM-STREAMS-STELLA-POSITION TAG
                  (LIST* (WRAP-CHARACTER #\ ) (WRAP-INTEGER 0) NIL))
                 NIL))
               (WRAP-STRING ">") SYM-STREAMS-STELLA-EOL NIL))
             NIL))))
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-PROGN
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (LIST* (WRAP-STRING "<") TAG (CONS (WRAP-STRING ">") NIL)))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (LIST* (WRAP-STRING "</")
               (LIST* SYM-STREAMS-STELLA-SUBSEQUENCE TAG
                (LIST* (WRAP-INTEGER 0)
                 (LIST* SYM-STREAMS-STELLA-POSITION TAG
                  (LIST* (WRAP-CHARACTER #\ ) (WRAP-INTEGER 0) NIL))
                 NIL))
               (WRAP-STRING ">") NIL))
             NIL)))))))
      ((SUBTYPE-OF? TEST-VALUE-001 SGT-STREAMS-STELLA-OBJECT)
       (CL:PROGN (CL:SETQ TAGVAR (GENSYM "TAG"))
        (CL:IF EOL?
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-LET
           (CONS (CONS TAGVAR (LIST* SYM-STREAMS-STELLA-STRING TAG NIL)) NIL)
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (LIST* (WRAP-STRING "<") TAGVAR (CONS (WRAP-STRING ">") NIL)))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (LIST* (WRAP-STRING "</")
               (LIST* SYM-STREAMS-STELLA-SUBSEQUENCE TAGVAR
                (LIST* (WRAP-INTEGER 0)
                 (LIST* SYM-STREAMS-STELLA-POSITION TAGVAR
                  (LIST* (WRAP-CHARACTER #\ ) (WRAP-INTEGER 0) NIL))
                 NIL))
               (WRAP-STRING ">") SYM-STREAMS-STELLA-EOL NIL))
             NIL))))
         (CL:RETURN-FROM EXPAND-MARKUP-TAG-FUNCTION
          (LIST* SYM-STREAMS-STELLA-LET
           (CONS (CONS TAGVAR (LIST* SYM-STREAMS-STELLA-STRING TAG NIL)) NIL)
           (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
            (LIST* (WRAP-STRING "<") TAGVAR (CONS (WRAP-STRING ">") NIL)))
           (CONCATENATE BODY
            (CONS
             (LIST* SYM-STREAMS-STELLA-PRINT-STREAM STREAM
              (LIST* (WRAP-STRING "</")
               (LIST* SYM-STREAMS-STELLA-SUBSEQUENCE TAGVAR
                (LIST* (WRAP-INTEGER 0)
                 (LIST* SYM-STREAMS-STELLA-POSITION TAGVAR
                  (LIST* (WRAP-CHARACTER #\ ) (WRAP-INTEGER 0) NIL))
                 NIL))
               (WRAP-STRING ">") NIL))
             NIL)))))))
      (CL:T
       (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
        (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
         "' is not a valid case option")
        (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001))))))))))

;;; (DEFMACRO WITH-HTML-TAG ...)

(CL:DEFUN WITH-HTML-TAG-EXPANDER (TAG-AND-STREAM BODY)
  (CL:RETURN-FROM WITH-HTML-TAG-EXPANDER
   (EXPAND-MARKUP-TAG-FUNCTION TAG-AND-STREAM BODY FALSE)))

;;; (DEFMACRO WITH-XML-TAG ...)

(CL:DEFUN WITH-XML-TAG-EXPANDER (TAG-AND-STREAM BODY)
  (CL:RETURN-FROM WITH-XML-TAG-EXPANDER
   (EXPAND-MARKUP-TAG-FUNCTION TAG-AND-STREAM BODY TRUE)))

;;; (DEFUN (TERMINATE-OUTPUT-STREAM? BOOLEAN) ...)

(CL:DEFUN TERMINATE-OUTPUT-STREAM? (SELF)
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)))
   (CL:WHEN (CL:NOT (CL:EQ NATIVE-STREAM NULL)) (CL:CLOSE NATIVE-STREAM))
   (CL:SETF (%NATIVE-STREAM SELF) NULL)
   (CL:SETF (%STATE SELF) KWD-STREAMS-CLOSED)
   (CL:RETURN-FROM TERMINATE-OUTPUT-STREAM? TRUE)))

;;; (DEFUN (TERMINATE-INPUT-STREAM? BOOLEAN) ...)

(CL:DEFUN TERMINATE-INPUT-STREAM? (SELF)
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)))
   (CL:WHEN (CL:NOT (CL:EQ NATIVE-STREAM NULL)) (CL:CLOSE NATIVE-STREAM))
   (CL:SETF (%NATIVE-STREAM SELF) NULL)
   (CL:SETF (%STATE SELF) KWD-STREAMS-CLOSED)
   (CL:RETURN-FROM TERMINATE-INPUT-STREAM? TRUE)))

;;; (DEFGLOBAL *OPEN-FILE-STREAMS* ...)

(CL:DEFVAR *OPEN-FILE-STREAMS* NULL
  "List of file streams that are currently open.")

;;; (DEFUN INITIALIZE-FILE-OUTPUT-STREAM ...)

(CL:DEFUN INITIALIZE-FILE-OUTPUT-STREAM (SELF)
  (CL:LET*
   ((FILENAME (TRANSLATE-LOGICAL-PATHNAME (%FILENAME SELF)))
    (IFEXISTSACTION (%SYMBOL-NAME (%IF-EXISTS-ACTION SELF))))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING FILENAME IFEXISTSACTION))
   (CL:SETF (%NATIVE-STREAM SELF)
    (CL:OPEN FILENAME :DIRECTION :OUTPUT :IF-EXISTS
     (CL:INTERN IFEXISTSACTION "KEYWORD")))
   (CL:WHEN (CL:EQ (%NATIVE-STREAM SELF) NULL)
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000)
      "initialize-file-output-stream: Could not open `" SELF "'")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))
   (CL:SETF (%STATE SELF) KWD-STREAMS-OPEN) (PUSH *OPEN-FILE-STREAMS* SELF))
  :VOID)

;;; (DEFUN (TERMINATE-FILE-OUTPUT-STREAM? BOOLEAN) ...)

(CL:DEFUN TERMINATE-FILE-OUTPUT-STREAM? (SELF)
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)))
   (CL:WHEN (CL:NOT (CL:EQ NATIVE-STREAM NULL)) (CL:CLOSE NATIVE-STREAM))
   (CL:SETF (%NATIVE-STREAM SELF) NULL)
   (CL:SETF (%STATE SELF) KWD-STREAMS-CLOSED) (REMOVE *OPEN-FILE-STREAMS* SELF)
   (CL:RETURN-FROM TERMINATE-FILE-OUTPUT-STREAM? TRUE)))

;;; (DEFUN INITIALIZE-FILE-INPUT-STREAM ...)

(CL:DEFUN INITIALIZE-FILE-INPUT-STREAM (SELF)
  (CL:LET*
   ((FILENAME (TRANSLATE-LOGICAL-PATHNAME (%FILENAME SELF)))
    (IFNOTEXISTSACTION (%SYMBOL-NAME (%IF-NOT-EXISTS-ACTION SELF))))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING FILENAME IFNOTEXISTSACTION))
   (CL:SETF (%NATIVE-STREAM SELF)
    (CL:OPEN FILENAME :DIRECTION :INPUT :IF-DOES-NOT-EXIST
     (CL:INTERN IFNOTEXISTSACTION "KEYWORD")))
   (CL:WHEN (CL:EQ (%NATIVE-STREAM SELF) NULL)
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000)
      "initialize-file-input-stream: Could not open `" SELF "'")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))
   (CL:SETF (%STATE SELF) KWD-STREAMS-OPEN) (PUSH *OPEN-FILE-STREAMS* SELF))
  :VOID)

;;; (DEFUN (TERMINATE-FILE-INPUT-STREAM? BOOLEAN) ...)

(CL:DEFUN TERMINATE-FILE-INPUT-STREAM? (SELF)
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)))
   (CL:WHEN (CL:NOT (CL:EQ NATIVE-STREAM NULL)) (CL:CLOSE NATIVE-STREAM))
   (CL:SETF (%NATIVE-STREAM SELF) NULL)
   (CL:SETF (%STATE SELF) KWD-STREAMS-CLOSED) (REMOVE *OPEN-FILE-STREAMS* SELF)
   (CL:RETURN-FROM TERMINATE-FILE-INPUT-STREAM? TRUE)))

;;; (DEFUN INITIALIZE-STRING-OUTPUT-STREAM ...)

(CL:DEFUN INITIALIZE-STRING-OUTPUT-STREAM (SELF)
  (CL:SETF (%NATIVE-STREAM SELF) (CL:MAKE-STRING-OUTPUT-STREAM))
  :VOID)

;;; (DEFMETHOD (THE-STRING-READER STRING) ...)

(CL:DEFMETHOD THE-STRING-READER ((SELF OUTPUT-STRING-STREAM))
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)) (STRING STELLA::NULL-STRING))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING STRING))
   (SETQ STRING (CL:GET-OUTPUT-STREAM-STRING NATIVE-STREAM))
   (CL:WHEN (CL:EQ STRING STELLA::NULL-STRING) (CL:SETQ STRING ""))
   (CL:RETURN-FROM THE-STRING-READER STRING)))
(CL:DECLAIM (CL:FTYPE (CL:FUNCTION (CL:T) CL:SIMPLE-STRING) THE-STRING-READER))

;;; (DEFUN INITIALIZE-STRING-INPUT-STREAM ...)

(CL:DEFUN INITIALIZE-STRING-INPUT-STREAM (SELF)
  (CL:LET* ((STRING (%THE-STRING SELF)))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING STRING))
   (CL:SETF (%NATIVE-STREAM SELF) (CL:MAKE-STRING-INPUT-STREAM STRING)))
  :VOID)

;;; (DEFUN CLOSE-STREAM ...)

(CL:DEFUN CLOSE-STREAM (SELF)
  "Close the stream `self'."
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE SELF)))
   (CL:COND
    ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-FILE-INPUT-STREAM)
     (CL:PROGN (TERMINATE-FILE-INPUT-STREAM? SELF)))
    ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-FILE-OUTPUT-STREAM)
     (CL:PROGN (TERMINATE-FILE-OUTPUT-STREAM? SELF)))
    ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-INPUT-STREAM)
     (CL:PROGN (TERMINATE-INPUT-STREAM? SELF)))
    ((SUBTYPE-OF? TEST-VALUE-000 SGT-STREAMS-STELLA-OUTPUT-STREAM)
     (CL:PROGN (TERMINATE-OUTPUT-STREAM? SELF)))
    (CL:T)))
  :VOID)

;;; (DEFUN FLUSH-OUTPUT ...)

(CL:DEFUN FLUSH-OUTPUT (SELF)
  "Flush all buffered output of `self'."
  (CL:LET* ((NATIVE-STREAM (%NATIVE-STREAM SELF)))
   (CL:FORCE-OUTPUT NATIVE-STREAM))
  :VOID)

;;; (DEFUN CLOSE-ALL-FILES ...)

(CL:DEFUN CLOSE-ALL-FILES ()
  "Close all currently open file streams.  Use for emergencies or for cleanup."
  (CL:LET* ((OPENSTREAMS (COPY *OPEN-FILE-STREAMS*)))
   (CL:LET* ((STREAM NULL) (ITER-000 (%THE-CONS-LIST OPENSTREAMS)))
    (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-000 NIL)) DO
     (CL:PROGN (CL:SETQ STREAM (%%VALUE ITER-000))
      (CL:SETQ ITER-000 (%%REST ITER-000)))
     (CLOSE-STREAM STREAM)))
   (FREE OPENSTREAMS))
  :VOID)

;;; (DEFUN (OPEN-NETWORK-STREAM INPUT-STREAM OUTPUT-STREAM) ...)

(CL:DEFUN OPEN-NETWORK-STREAM (HOST PORT)
  "Open a TCP/IP network stream to `host' at `port' and return the result
as an input/output stream pair."
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING HOST) (CL:TYPE CL:FIXNUM PORT))
  (CL:LET* ((IN NULL) (OUT NULL)) (setq in (%%open-network-stream host port))
   (setq out in)

   (CL:LET* ((SELF-000 (NEW-INPUT-STREAM)))
    (CL:SETF (%NATIVE-STREAM SELF-000) IN)
    (CL:SETF (%STATE SELF-000) KWD-STREAMS-OPEN)
    (CL:LET* ((VALUE-000 SELF-000))
     (CL:LET* ((SELF-001 (NEW-OUTPUT-STREAM)))
      (CL:SETF (%NATIVE-STREAM SELF-001) OUT)
      (CL:SETF (%STATE SELF-001) KWD-STREAMS-OPEN)
      (CL:LET* ((VALUE-001 SELF-001))
       (CL:RETURN-FROM OPEN-NETWORK-STREAM (CL:VALUES VALUE-000 VALUE-001))))))))

;;; (DEFGLOBAL *HTML-QUOTED-CHARACTERS* ...)

(CL:DEFVAR *HTML-QUOTED-CHARACTERS* "><&\"")
(CL:DECLAIM (CL:TYPE CL:SIMPLE-STRING *HTML-QUOTED-CHARACTERS*))

;;; (DEFUN (HTML-CHARACTER-NEEDS-QUOTING? BOOLEAN) ...)

(CL:DEFUN HTML-CHARACTER-NEEDS-QUOTING? (CH)
  (CL:RETURN-FROM HTML-CHARACTER-NEEDS-QUOTING?
   (MEMBER? *HTML-QUOTED-CHARACTERS* CH)))

;;; (DEFUN WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS ...)

(CL:DEFUN WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS (STREAM CH)
  (CL:CASE CH (#\> (%%PRINT-STREAM STREAM "&gt;"))
   (#\< (%%PRINT-STREAM STREAM "&lt;")) (#\& (%%PRINT-STREAM STREAM "&amp;"))
   (#\" (%%PRINT-STREAM STREAM "&quot;"))
   (CL:OTHERWISE (%%PRINT-STREAM STREAM CH)))
  (CL:RETURN-FROM WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS)
  :VOID)

;;; (DEFUN WRITE-HTML-QUOTING-SPECIAL-CHARACTERS ...)

(CL:DEFUN WRITE-HTML-QUOTING-SPECIAL-CHARACTERS (STREAM INPUT)
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING INPUT))
  (CL:LET*
   ((CH NULL-CHARACTER) (VECTOR-000 INPUT) (INDEX-000 0)
    (LENGTH-000 (CL:THE CL:FIXNUM (CL:LENGTH VECTOR-000))))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING VECTOR-000)
    (CL:TYPE CL:FIXNUM INDEX-000 LENGTH-000))
   (CL:LOOP WHILE (CL:< INDEX-000 LENGTH-000) DO
    (CL:PROGN
     (CL:SETQ CH
      (CL:LET ((SELF VECTOR-000) (POSITION INDEX-000))
       (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF) (CL:TYPE CL:FIXNUM POSITION))
       (CL:AREF (CL:THE CL:SIMPLE-STRING SELF) (CL:THE CL:FIXNUM POSITION))))
     (CL:SETQ INDEX-000 (CL:1+ INDEX-000)))
    (WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS STREAM CH)))
  (CL:RETURN-FROM WRITE-HTML-QUOTING-SPECIAL-CHARACTERS)
  :VOID)

;;; (DEFUN WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS ...)

(CL:DEFUN WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS (STREAM INPUT)
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING INPUT))
  (CL:LET*
   ((CH NULL-CHARACTER) (VECTOR-000 INPUT) (INDEX-000 0)
    (LENGTH-000 (CL:THE CL:FIXNUM (CL:LENGTH VECTOR-000))))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING VECTOR-000)
    (CL:TYPE CL:FIXNUM INDEX-000 LENGTH-000))
   (CL:LOOP WHILE (CL:< INDEX-000 LENGTH-000) DO
    (CL:PROGN
     (CL:SETQ CH
      (CL:LET ((SELF VECTOR-000) (POSITION INDEX-000))
       (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF) (CL:TYPE CL:FIXNUM POSITION))
       (CL:AREF (CL:THE CL:SIMPLE-STRING SELF) (CL:THE CL:FIXNUM POSITION))))
     (CL:SETQ INDEX-000 (CL:1+ INDEX-000)))
    (CL:CASE CH (#\  (%%PRINT-STREAM STREAM "%20"))
     (#\? (%%PRINT-STREAM STREAM "%3F")) (#\# (%%PRINT-STREAM STREAM "%23"))
     (#\= (%%PRINT-STREAM STREAM "%3D")) (#\& (%%PRINT-STREAM STREAM "%26"))
     (#\% (%%PRINT-STREAM STREAM "%25")) (#\+ (%%PRINT-STREAM STREAM "%2B"))
     (#\< (%%PRINT-STREAM STREAM "%3C")) (#\> (%%PRINT-STREAM STREAM "%3E"))
     (#\/ (%%PRINT-STREAM STREAM "%2F")) (#\: (%%PRINT-STREAM STREAM "%3A"))
     (#\" (%%PRINT-STREAM STREAM "%22"))
     (CL:OTHERWISE (%%PRINT-STREAM STREAM CH)))))
  (CL:RETURN-FROM WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS)
  :VOID)

;;; (DEFGLOBAL *HTML-ESCAPE-TABLE* ...)

(CL:DEFVAR *HTML-ESCAPE-TABLE* NULL)

;;; (DEFUN (UNESCAPE-HTML-STRING STRING) ...)

(CL:DEFUN UNESCAPE-HTML-STRING (INPUT)
  "Replaces HTML escape sequences such as &amp; with their associated
characters."
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING INPUT))
  (CL:WHEN (CL:NOT (DEFINED? (POSITION INPUT #\& 0)))
   (CL:RETURN-FROM UNESCAPE-HTML-STRING INPUT))
  (CL:LET*
   ((OUT (NEW-OUTPUT-STRING-STREAM)) (ESCAPE-STRING STELLA::NULL-STRING))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING ESCAPE-STRING))
   (CL:LET*
    ((CH NULL-CHARACTER) (VECTOR-000 INPUT) (INDEX-000 0)
     (LENGTH-000 (CL:THE CL:FIXNUM (CL:LENGTH VECTOR-000))))
    (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING VECTOR-000)
     (CL:TYPE CL:FIXNUM INDEX-000 LENGTH-000))
    (CL:LOOP WHILE (CL:< INDEX-000 LENGTH-000) DO
     (CL:PROGN
      (CL:SETQ CH
       (CL:LET ((SELF VECTOR-000) (POSITION INDEX-000))
        (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
         (CL:TYPE CL:FIXNUM POSITION))
        (CL:AREF (CL:THE CL:SIMPLE-STRING SELF) (CL:THE CL:FIXNUM POSITION))))
      (CL:SETQ INDEX-000 (CL:1+ INDEX-000)))
     (CL:CASE CH
      (#\&
       (CL:WHEN (CL:NOT (CL:EQ ESCAPE-STRING STELLA::NULL-STRING))
        (CL:ERROR (NEW-STELLA-EXCEPTION "& inside escape sequence!")))
       (CL:SETQ ESCAPE-STRING ""))
      (#\;
       (CL:IF (CL:NOT (CL:EQ ESCAPE-STRING STELLA::NULL-STRING))
        (CL:PROGN
         (CL:IF
          (CL:NOT
           (CL:EQ (LOOKUP *HTML-ESCAPE-TABLE* (WRAP-STRING ESCAPE-STRING))
            NULL))
          (%%PRINT-STREAM (%NATIVE-STREAM OUT)
           (%WRAPPER-VALUE
            (LOOKUP *HTML-ESCAPE-TABLE* (WRAP-STRING ESCAPE-STRING))))
          (%%PRINT-STREAM (%NATIVE-STREAM OUT) "&" ESCAPE-STRING ";"))
         (CL:SETQ ESCAPE-STRING STELLA::NULL-STRING))
        (%%PRINT-STREAM (%NATIVE-STREAM OUT) ";")))
      (CL:OTHERWISE
       (CL:IF (CL:NOT (CL:EQ ESCAPE-STRING STELLA::NULL-STRING))
        (CL:SETQ ESCAPE-STRING (CONCATENATE ESCAPE-STRING (MAKE-STRING 1 CH)))
        (%%PRINT-STREAM (%NATIVE-STREAM OUT) CH))))))
   (CL:RETURN-FROM UNESCAPE-HTML-STRING (THE-STRING-READER OUT))))
(CL:DECLAIM
 (CL:FTYPE (CL:FUNCTION (CL:SIMPLE-STRING) CL:SIMPLE-STRING)
  UNESCAPE-HTML-STRING))

;;; (DEFCLASS STREAM-ITERATOR ...)

(CL:DEFCLASS STREAM-ITERATOR (ABSTRACT-ITERATOR)
  ((THE-STREAM :ALLOCATION :INSTANCE :ACCESSOR %THE-STREAM))
  (:DOCUMENTATION "Iterator that yields tokens from an input stream."))

(CL:DEFUN ACCESS-STREAM-ITERATOR-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME SYM-STREAMS-STELLA-THE-STREAM)
    (CL:IF SETVALUE? (CL:SETF (%THE-STREAM SELF) VALUE)
     (CL:SETQ VALUE (%THE-STREAM SELF))))
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" SLOTNAME
      "' is not a valid case option")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))
  (CL:RETURN-FROM ACCESS-STREAM-ITERATOR-SLOT-VALUE VALUE))

;;; (DEFCLASS S-EXPRESSION-ITERATOR ...)

(CL:DEFCLASS S-EXPRESSION-ITERATOR (STREAM-ITERATOR)
  ((VALUE :DOCUMENTATION "The current value of this iterator" :ALLOCATION
    :INSTANCE :ACCESSOR %VALUE))
  (:DOCUMENTATION "Iterator that yields s-expressions from an input stream."))

(CL:DEFUN NEW-S-EXPRESSION-ITERATOR ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF (CL:MAKE-INSTANCE (CL:QUOTE S-EXPRESSION-ITERATOR)))
   (CL:SETF (%FIRST-ITERATION? SELF) TRUE) (CL:SETF (%VALUE SELF) NULL)
   (CL:SETF (%THE-STREAM SELF) NULL)
   (CL:RETURN-FROM NEW-S-EXPRESSION-ITERATOR SELF)))

(CL:DEFMETHOD FREE ((SELF S-EXPRESSION-ITERATOR))
  (CL:WHEN (TERMINATE-STREAM-ITERATOR? SELF) (UNMAKE SELF))
  :VOID)

(CL:DEFMETHOD PRIMARY-TYPE ((SELF S-EXPRESSION-ITERATOR))
  (CL:RETURN-FROM PRIMARY-TYPE SGT-STREAMS-STELLA-S-EXPRESSION-ITERATOR))

;;; (DEFCLASS LINE-ITERATOR ...)

(CL:DEFCLASS LINE-ITERATOR (STREAM-ITERATOR)
  ((VALUE :DOCUMENTATION "The current value of this iterator" :ALLOCATION
    :INSTANCE :ACCESSOR %VALUE))
  (:DOCUMENTATION "Iterator that yields lines from an input stream."))

(CL:DEFUN NEW-LINE-ITERATOR ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF (CL:MAKE-INSTANCE (CL:QUOTE LINE-ITERATOR)))
   (CL:SETF (%FIRST-ITERATION? SELF) TRUE)
   (CL:SETF (%VALUE SELF) STELLA::NULL-STRING) (CL:SETF (%THE-STREAM SELF) NULL)
   (CL:RETURN-FROM NEW-LINE-ITERATOR SELF)))

(CL:DEFMETHOD FREE ((SELF LINE-ITERATOR))
  (CL:WHEN (TERMINATE-STREAM-ITERATOR? SELF) (UNMAKE SELF))
  :VOID)

(CL:DEFMETHOD PRIMARY-TYPE ((SELF LINE-ITERATOR))
  (CL:RETURN-FROM PRIMARY-TYPE SGT-STREAMS-STELLA-LINE-ITERATOR))

;;; (DEFCLASS CHARACTER-ITERATOR ...)

(CL:DEFCLASS CHARACTER-ITERATOR (STREAM-ITERATOR)
  ((VALUE :DOCUMENTATION "The current value of this iterator" :ALLOCATION
    :INSTANCE :ACCESSOR %VALUE))
  (:DOCUMENTATION "Iterator that yields characters from an input stream."))

(CL:DEFUN NEW-CHARACTER-ITERATOR ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF (CL:MAKE-INSTANCE (CL:QUOTE CHARACTER-ITERATOR)))
   (CL:SETF (%FIRST-ITERATION? SELF) TRUE)
   (CL:SETF (%VALUE SELF) NULL-CHARACTER) (CL:SETF (%THE-STREAM SELF) NULL)
   (CL:RETURN-FROM NEW-CHARACTER-ITERATOR SELF)))

(CL:DEFMETHOD FREE ((SELF CHARACTER-ITERATOR))
  (CL:WHEN (TERMINATE-STREAM-ITERATOR? SELF) (UNMAKE SELF))
  :VOID)

(CL:DEFMETHOD PRIMARY-TYPE ((SELF CHARACTER-ITERATOR))
  (CL:RETURN-FROM PRIMARY-TYPE SGT-STREAMS-STELLA-CHARACTER-ITERATOR))

;;; (DEFUN (TERMINATE-STREAM-ITERATOR? BOOLEAN) ...)

(CL:DEFUN TERMINATE-STREAM-ITERATOR? (SELF)
  (CL:WHEN (CL:NOT (CL:EQ (%THE-STREAM SELF) NULL)) (FREE (%THE-STREAM SELF)))
  (CL:RETURN-FROM TERMINATE-STREAM-ITERATOR? TRUE))

;;; (DEFUN (S-EXPRESSIONS S-EXPRESSION-ITERATOR) ...)

(CL:DEFUN S-EXPRESSIONS (STREAM)
  (CL:LET* ((SELF-000 (NEW-S-EXPRESSION-ITERATOR)))
   (CL:SETF (%THE-STREAM SELF-000) STREAM)
   (CL:LET* ((VALUE-000 SELF-000)) (CL:RETURN-FROM S-EXPRESSIONS VALUE-000))))

;;; (DEFMETHOD (NEXT? BOOLEAN) ...)

(CL:DEFMETHOD NEXT? ((SELF S-EXPRESSION-ITERATOR))
  (CL:SETF (%FIRST-ITERATION? SELF) FALSE)
  (CL:LET* ((OBJECT NULL) (EOF? FALSE))
   (CL:MULTIPLE-VALUE-SETQ (OBJECT EOF?) (READ-S-EXPRESSION (%THE-STREAM SELF)))
   (CL:COND
    (EOF? (CLOSE-STREAM (%THE-STREAM SELF)) (CL:RETURN-FROM NEXT? FALSE))
    (CL:T (CL:SETF (%VALUE SELF) OBJECT) (CL:RETURN-FROM NEXT? TRUE)))))

;;; (DEFUN (LINES LINE-ITERATOR) ...)

(CL:DEFUN LINES (STREAM)
  (CL:LET* ((SELF-000 (NEW-LINE-ITERATOR)))
   (CL:SETF (%THE-STREAM SELF-000) STREAM)
   (CL:LET* ((VALUE-000 SELF-000)) (CL:RETURN-FROM LINES VALUE-000))))

;;; (DEFMETHOD (NEXT? BOOLEAN) ...)

(CL:DEFMETHOD NEXT? ((SELF LINE-ITERATOR))
  (CL:SETF (%FIRST-ITERATION? SELF) FALSE)
  (CL:LET* ((LINE STELLA::NULL-STRING) (EOF? FALSE))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING LINE))
   (CL:MULTIPLE-VALUE-SETQ (LINE EOF?) (READ-LINE (%THE-STREAM SELF)))
   (CL:COND
    (EOF? (CLOSE-STREAM (%THE-STREAM SELF)) (CL:RETURN-FROM NEXT? FALSE))
    (CL:T (CL:SETF (%VALUE SELF) LINE) (CL:RETURN-FROM NEXT? TRUE)))))

;;; (DEFUN (CHARACTERS CHARACTER-ITERATOR) ...)

(CL:DEFUN CHARACTERS (STREAM)
  (CL:LET* ((SELF-000 (NEW-CHARACTER-ITERATOR)))
   (CL:SETF (%THE-STREAM SELF-000) STREAM)
   (CL:LET* ((VALUE-000 SELF-000)) (CL:RETURN-FROM CHARACTERS VALUE-000))))

;;; (DEFMETHOD (NEXT? BOOLEAN) ...)

(CL:DEFMETHOD NEXT? ((SELF CHARACTER-ITERATOR))
  (CL:SETF (%FIRST-ITERATION? SELF) FALSE)
  (CL:LET* ((CHAR NULL-CHARACTER) (EOF? FALSE))
   (CL:MULTIPLE-VALUE-SETQ (CHAR EOF?) (READ-CHARACTER (%THE-STREAM SELF)))
   (CL:COND
    (EOF? (CLOSE-STREAM (%THE-STREAM SELF)) (CL:RETURN-FROM NEXT? FALSE))
    (CL:T (CL:SETF (%VALUE SELF) CHAR) (CL:RETURN-FROM NEXT? TRUE)))))

(CL:DEFUN HELP-STARTUP-STREAMS1 ()
  (CL:PROGN
   (CL:SETQ SYM-STREAMS-STELLA-EOL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EOL" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-PRINT-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PRINT-STREAM" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-STANDARD-OUTPUT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STANDARD-OUTPUT" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-PRINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PRINT" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-PRINT-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PRINT-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-INFORM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INFORM" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-INFORM-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INFORM-EXPANDER" NULL 0))
   (CL:SETQ KWD-STREAMS-COMMON-LISP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMMON-LISP" NULL 2))
   (CL:SETQ KWD-STREAMS-WARN (INTERN-RIGID-SYMBOL-WRT-MODULE "WARN" NULL 2))
   (CL:SETQ SYM-STREAMS-STELLA-STANDARD-WARNING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STANDARD-WARNING" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WARN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WARN" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WARN-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WARN-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-NULL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NULL" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-STELLA-EXCEPTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STELLA-EXCEPTION" NULL 0))
   (CL:SETQ SGT-STREAMS-STELLA-STRING-WRAPPER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRING-WRAPPER" NULL 1))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-EXCEPTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-EXCEPTION" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-NEW
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NEW" NULL 0))
   (CL:SETQ KWD-STREAMS-MESSAGE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MESSAGE" NULL 2))
   (CL:SETQ SYM-STREAMS-STELLA-LET
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LET" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-OUTPUT-STRING-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OUTPUT-STRING-STREAM" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-THE-STRING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "THE-STRING" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-ERROR-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ERROR-EXPANDER" NULL 0))
   (CL:SETQ KWD-STREAMS-JAVA (INTERN-RIGID-SYMBOL-WRT-MODULE "JAVA" NULL 2))
   (CL:SETQ SYM-STREAMS-STELLA-ERROR_MESSAGE_
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ERROR_MESSAGE_" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-VERBATIM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VERBATIM" NULL 0))
   (CL:SETQ KWD-STREAMS-CONTINUABLE-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTINUABLE-ERROR" NULL 2))
   (CL:SETQ SYM-STREAMS-STELLA-CONTINUABLE-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTINUABLE-ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-CONTINUABLE-ERROR-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTINUABLE-ERROR-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-READ-EXCEPTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "READ-EXCEPTION" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-READ-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-READ-ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-READ-ERROR-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-READ-ERROR-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-DE-UGLIFY-PARSE-TREE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DE-UGLIFY-PARSE-TREE" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SPECIAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SPECIAL" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-*PRINTREADABLY?*
    (INTERN-RIGID-SYMBOL-WRT-MODULE "*PRINTREADABLY?*" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-TRUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TRUE" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-TRANSLATION-ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-UNLESS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "UNLESS" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SUPPRESS-WARNINGS?
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUPPRESS-WARNINGS?" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-PRINT-ERROR-CONTEXT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PRINT-ERROR-CONTEXT" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-STANDARD-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STANDARD-ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-ERROR" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-ERROR-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-ERROR-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SIGNAL-TRANSLATION-WARNING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SIGNAL-TRANSLATION-WARNING" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-INFORM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-INFORM" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-INFORM-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-INFORM-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-WARN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-WARN" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WALK-WARN-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WALK-WARN-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WHEN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WHEN" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-NOT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NOT" NULL 0))
   (CL:SETQ KWD-STREAMS-ERROR (INTERN-RIGID-SYMBOL-WRT-MODULE "ERROR" NULL 2))
   (CL:SETQ SYM-STREAMS-STELLA-SAFETY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SAFETY" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SAFETY-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SAFETY-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-*EVALUATIONTREE*
    (INTERN-RIGID-SYMBOL-WRT-MODULE "*EVALUATIONTREE*" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-DEFINED?
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DEFINED?" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-*EVALUATIONPARENTTREE*
    (INTERN-RIGID-SYMBOL-WRT-MODULE "*EVALUATIONPARENTTREE*" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-EVALUATION-EXCEPTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EVALUATION-EXCEPTION" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-EVALUATION-ERROR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EVALUATION-ERROR" NULL 0)))
  :VOID)

(CL:DEFUN HELP-STARTUP-STREAMS2 ()
  (CL:PROGN
   (CL:SETQ SYM-STREAMS-STELLA-EVALUATION-ERROR-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EVALUATION-ERROR-EXPANDER" NULL 0))
   (CL:SETQ SGT-STREAMS-STELLA-LITERAL-WRAPPER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LITERAL-WRAPPER" NULL 1))
   (CL:SETQ SYM-STREAMS-STELLA-STRINGIFY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRINGIFY" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-VRLET
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VRLET" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-STRING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRING" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SETQ
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SETQ" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-CONCATENATE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONCATENATE" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-MESSAGE-TO-STRING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MESSAGE-TO-STRING" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-MESSAGE-TO-STRING-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MESSAGE-TO-STRING-EXPANDER" NULL 0))
   (CL:SETQ SGT-STREAMS-STELLA-OBJECT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OBJECT" NULL 1))
   (CL:SETQ SYM-STREAMS-STELLA-PROGN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROGN" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-SUBSEQUENCE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUBSEQUENCE" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-POSITION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "POSITION" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WITH-HTML-TAG
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WITH-HTML-TAG" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WITH-HTML-TAG-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WITH-HTML-TAG-EXPANDER" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WITH-XML-TAG
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WITH-XML-TAG" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-WITH-XML-TAG-EXPANDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WITH-XML-TAG-EXPANDER" NULL 0))
   (CL:SETQ KWD-STREAMS-CLOSED (INTERN-RIGID-SYMBOL-WRT-MODULE "CLOSED" NULL 2))
   (CL:SETQ KWD-STREAMS-OPEN (INTERN-RIGID-SYMBOL-WRT-MODULE "OPEN" NULL 2))
   (CL:SETQ SGT-STREAMS-STELLA-FILE-INPUT-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FILE-INPUT-STREAM" NULL 1))
   (CL:SETQ SGT-STREAMS-STELLA-FILE-OUTPUT-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FILE-OUTPUT-STREAM" NULL 1))
   (CL:SETQ SGT-STREAMS-STELLA-INPUT-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INPUT-STREAM" NULL 1))
   (CL:SETQ SGT-STREAMS-STELLA-OUTPUT-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OUTPUT-STREAM" NULL 1))
   (CL:SETQ SYM-STREAMS-STELLA-THE-STREAM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "THE-STREAM" NULL 0))
   (CL:SETQ SGT-STREAMS-STELLA-S-EXPRESSION-ITERATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "S-EXPRESSION-ITERATOR" NULL 1))
   (CL:SETQ SGT-STREAMS-STELLA-LINE-ITERATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LINE-ITERATOR" NULL 1))
   (CL:SETQ SGT-STREAMS-STELLA-CHARACTER-ITERATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CHARACTER-ITERATOR" NULL 1))
   (CL:SETQ SYM-STREAMS-STELLA-STARTUP-STREAMS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STARTUP-STREAMS" NULL 0))
   (CL:SETQ SYM-STREAMS-STELLA-METHOD-STARTUP-CLASSNAME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "METHOD-STARTUP-CLASSNAME" NULL 0)))
  :VOID)

(CL:DEFUN HELP-STARTUP-STREAMS3 ()
  (CL:PROGN
   (DEFINE-FUNCTION-OBJECT "FORMAT-MESSAGE-ARGUMENTS"
    "(DEFUN (FORMAT-MESSAGE-ARGUMENTS CONS) ((MESSAGEARGUMENTSTREE CONS) (TRAILINGEOL? BOOLEAN)))"
    (CL:FUNCTION FORMAT-MESSAGE-ARGUMENTS) NULL)
   (DEFINE-FUNCTION-OBJECT "PRINT-EXPANDER"
    "(DEFUN (PRINT-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Print arguments to the standard output stream.\")"
    (CL:FUNCTION PRINT-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "INFORM-EXPANDER"
    "(DEFUN (INFORM-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Print informative message, placing non-string arguments in quotes,
and terminating with a newline.\")" (CL:FUNCTION INFORM-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "WARN-EXPANDER"
    "(DEFUN (WARN-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Signal warning message, placing non-string arguments in quotes.\")"
    (CL:FUNCTION WARN-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "SIGNAL-EXPANDER"
    "(DEFUN (SIGNAL-EXPANDER OBJECT) ((TYPE SYMBOL) |&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Signal error message, placing non-string arguments in quotes.\")"
    (CL:FUNCTION SIGNAL-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "ERROR-EXPANDER"
    "(DEFUN (ERROR-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Signal error message, placing non-string arguments in quotes.\")"
    (CL:FUNCTION ERROR-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "CONTINUABLE-ERROR-EXPANDER"
    "(DEFUN (CONTINUABLE-ERROR-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Signal error message, placing non-string arguments in quotes.\")"
    (CL:FUNCTION CONTINUABLE-ERROR-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "SIGNAL-READ-ERROR-EXPANDER"
    "(DEFUN (SIGNAL-READ-ERROR-EXPANDER OBJECT) (|&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Specialized version of `signal' that throws a READ-EXCEPTION.\")"
    (CL:FUNCTION SIGNAL-READ-ERROR-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "FORMAT-WALK-MESSAGE-ARGUMENTS"
    "(DEFUN (FORMAT-WALK-MESSAGE-ARGUMENTS CONS) ((MESSAGEARGUMENTSTREE CONS)))"
    (CL:FUNCTION FORMAT-WALK-MESSAGE-ARGUMENTS) NULL)
   (DEFINE-FUNCTION-OBJECT "WALK-ERROR-EXPANDER"
    "(DEFUN (WALK-ERROR-EXPANDER OBJECT) (|&BODY| (BODY CONS)))"
    (CL:FUNCTION WALK-ERROR-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "WALK-INFORM-EXPANDER"
    "(DEFUN (WALK-INFORM-EXPANDER OBJECT) (|&BODY| (BODY CONS)))"
    (CL:FUNCTION WALK-INFORM-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "WALK-WARN-EXPANDER"
    "(DEFUN (WALK-WARN-EXPANDER OBJECT) (|&BODY| (BODY CONS)))"
    (CL:FUNCTION WALK-WARN-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "SAFETY-EXPANDER"
    "(DEFUN (SAFETY-EXPANDER OBJECT) ((LEVEL INTEGER-WRAPPER) (TEST OBJECT) |&BODY| (BODY CONS)) :PUBLIC? TRUE :DOCUMENTATION \"Signal warning message, placing non-string arguments in quotes.\")"
    (CL:FUNCTION SAFETY-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "EVALUATION-ERROR-EXPANDER"
    "(DEFUN (EVALUATION-ERROR-EXPANDER OBJECT) (|&BODY| (BODY CONS)))"
    (CL:FUNCTION EVALUATION-ERROR-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "FORMAT-STRING-MESSAGE-ARGUMENTS"
    "(DEFUN (FORMAT-STRING-MESSAGE-ARGUMENTS CONS) ((MESSAGEARGUMENTS CONS) (TRAILINGEOL? BOOLEAN)))"
    (CL:FUNCTION FORMAT-STRING-MESSAGE-ARGUMENTS) NULL)
   (DEFINE-FUNCTION-OBJECT "MESSAGE-TO-STRING-EXPANDER"
    "(DEFUN (MESSAGE-TO-STRING-EXPANDER OBJECT) (|&BODY| (BODY CONS)))"
    (CL:FUNCTION MESSAGE-TO-STRING-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "EXPAND-MARKUP-TAG-FUNCTION"
    "(DEFUN (EXPAND-MARKUP-TAG-FUNCTION CONS) ((TAG-AND-STREAM CONS) (BODY CONS) (XML? BOOLEAN)))"
    (CL:FUNCTION EXPAND-MARKUP-TAG-FUNCTION) NULL)
   (DEFINE-FUNCTION-OBJECT "WITH-HTML-TAG-EXPANDER"
    "(DEFUN (WITH-HTML-TAG-EXPANDER OBJECT) ((TAG-AND-STREAM CONS) |&BODY| (BODY CONS)))"
    (CL:FUNCTION WITH-HTML-TAG-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "WITH-XML-TAG-EXPANDER"
    "(DEFUN (WITH-XML-TAG-EXPANDER OBJECT) ((TAG-AND-STREAM CONS) |&BODY| (BODY CONS)))"
    (CL:FUNCTION WITH-XML-TAG-EXPANDER) NULL)
   (DEFINE-FUNCTION-OBJECT "TERMINATE-OUTPUT-STREAM?"
    "(DEFUN (TERMINATE-OUTPUT-STREAM? BOOLEAN) ((SELF OUTPUT-STREAM)))"
    (CL:FUNCTION TERMINATE-OUTPUT-STREAM?) NULL)
   (DEFINE-FUNCTION-OBJECT "TERMINATE-INPUT-STREAM?"
    "(DEFUN (TERMINATE-INPUT-STREAM? BOOLEAN) ((SELF INPUT-STREAM)))"
    (CL:FUNCTION TERMINATE-INPUT-STREAM?) NULL)
   (DEFINE-FUNCTION-OBJECT "INITIALIZE-FILE-OUTPUT-STREAM"
    "(DEFUN INITIALIZE-FILE-OUTPUT-STREAM ((SELF FILE-OUTPUT-STREAM)))"
    (CL:FUNCTION INITIALIZE-FILE-OUTPUT-STREAM) NULL)
   (DEFINE-FUNCTION-OBJECT "TERMINATE-FILE-OUTPUT-STREAM?"
    "(DEFUN (TERMINATE-FILE-OUTPUT-STREAM? BOOLEAN) ((SELF FILE-OUTPUT-STREAM)))"
    (CL:FUNCTION TERMINATE-FILE-OUTPUT-STREAM?) NULL)
   (DEFINE-FUNCTION-OBJECT "INITIALIZE-FILE-INPUT-STREAM"
    "(DEFUN INITIALIZE-FILE-INPUT-STREAM ((SELF FILE-INPUT-STREAM)))"
    (CL:FUNCTION INITIALIZE-FILE-INPUT-STREAM) NULL)
   (DEFINE-FUNCTION-OBJECT "TERMINATE-FILE-INPUT-STREAM?"
    "(DEFUN (TERMINATE-FILE-INPUT-STREAM? BOOLEAN) ((SELF FILE-INPUT-STREAM)))"
    (CL:FUNCTION TERMINATE-FILE-INPUT-STREAM?) NULL)
   (DEFINE-FUNCTION-OBJECT "INITIALIZE-STRING-OUTPUT-STREAM"
    "(DEFUN INITIALIZE-STRING-OUTPUT-STREAM ((SELF STRING-OUTPUT-STREAM)))"
    (CL:FUNCTION INITIALIZE-STRING-OUTPUT-STREAM) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD (THE-STRING-READER STRING) ((SELF STRING-OUTPUT-STREAM)))"
    (CL:FUNCTION THE-STRING-READER) NULL)
   (DEFINE-FUNCTION-OBJECT "INITIALIZE-STRING-INPUT-STREAM"
    "(DEFUN INITIALIZE-STRING-INPUT-STREAM ((SELF STRING-INPUT-STREAM)))"
    (CL:FUNCTION INITIALIZE-STRING-INPUT-STREAM) NULL)
   (DEFINE-FUNCTION-OBJECT "CLOSE-STREAM"
    "(DEFUN CLOSE-STREAM ((SELF STREAM)) :DOCUMENTATION \"Close the stream `self'.\" :PUBLIC? TRUE)"
    (CL:FUNCTION CLOSE-STREAM) NULL)
   (DEFINE-FUNCTION-OBJECT "FLUSH-OUTPUT"
    "(DEFUN FLUSH-OUTPUT ((SELF OUTPUT-STREAM)) :DOCUMENTATION \"Flush all buffered output of `self'.\" :PUBLIC? TRUE)"
    (CL:FUNCTION FLUSH-OUTPUT) NULL)
   (DEFINE-FUNCTION-OBJECT "CLOSE-ALL-FILES"
    "(DEFUN CLOSE-ALL-FILES () :DOCUMENTATION \"Close all currently open file streams.  Use for emergencies or for cleanup.\" :PUBLIC? TRUE)"
    (CL:FUNCTION CLOSE-ALL-FILES) NULL)
   (DEFINE-FUNCTION-OBJECT "OPEN-NETWORK-STREAM"
    "(DEFUN (OPEN-NETWORK-STREAM INPUT-STREAM OUTPUT-STREAM) ((HOST STRING) (PORT INTEGER)) :DOCUMENTATION \"Open a TCP/IP network stream to `host' at `port' and return the result
as an input/output stream pair.\" :PUBLIC? TRUE)"
    (CL:FUNCTION OPEN-NETWORK-STREAM) NULL)
   (DEFINE-FUNCTION-OBJECT "HTML-CHARACTER-NEEDS-QUOTING?"
    "(DEFUN (HTML-CHARACTER-NEEDS-QUOTING? BOOLEAN) ((CH CHARACTER)))"
    (CL:FUNCTION HTML-CHARACTER-NEEDS-QUOTING?) NULL)
   (DEFINE-FUNCTION-OBJECT "WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS"
    "(DEFUN WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS ((STREAM NATIVE-OUTPUT-STREAM) (CH CHARACTER)) :GLOBALLY-INLINE? TRUE (CASE CH (#\\> (PRINT-STREAM STREAM \"&gt;\")) (#\\< (PRINT-STREAM STREAM \"&lt;\")) (#\\& (PRINT-STREAM STREAM \"&amp;\")) (#\\\" (PRINT-STREAM STREAM \"&quot;\")) (OTHERWISE (PRINT-STREAM STREAM CH))) (RETURN))"
    (CL:FUNCTION WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS) NULL)
   (DEFINE-FUNCTION-OBJECT "WRITE-HTML-QUOTING-SPECIAL-CHARACTERS"
    "(DEFUN WRITE-HTML-QUOTING-SPECIAL-CHARACTERS ((STREAM NATIVE-OUTPUT-STREAM) (INPUT STRING)))"
    (CL:FUNCTION WRITE-HTML-QUOTING-SPECIAL-CHARACTERS) NULL)
   (DEFINE-FUNCTION-OBJECT "WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS"
    "(DEFUN WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS ((STREAM NATIVE-OUTPUT-STREAM) (INPUT STRING)))"
    (CL:FUNCTION WRITE-HTML-ESCAPING-URL-SPECIAL-CHARACTERS) NULL)
   (DEFINE-FUNCTION-OBJECT "UNESCAPE-HTML-STRING"
    "(DEFUN (UNESCAPE-HTML-STRING STRING) ((INPUT STRING)) :PUBLIC? TRUE :DOCUMENTATION \"Replaces HTML escape sequences such as &amp; with their associated
characters.\")" (CL:FUNCTION UNESCAPE-HTML-STRING) NULL)
   (DEFINE-FUNCTION-OBJECT "TERMINATE-STREAM-ITERATOR?"
    "(DEFUN (TERMINATE-STREAM-ITERATOR? BOOLEAN) ((SELF STREAM-ITERATOR)))"
    (CL:FUNCTION TERMINATE-STREAM-ITERATOR?) NULL)
   (DEFINE-FUNCTION-OBJECT "S-EXPRESSIONS"
    "(DEFUN (S-EXPRESSIONS S-EXPRESSION-ITERATOR) ((STREAM INPUT-STREAM)) :PUBLIC? TRUE)"
    (CL:FUNCTION S-EXPRESSIONS) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD (NEXT? BOOLEAN) ((SELF S-EXPRESSION-ITERATOR)) :PUBLIC? TRUE)"
    (CL:FUNCTION NEXT?) NULL)
   (DEFINE-FUNCTION-OBJECT "LINES"
    "(DEFUN (LINES LINE-ITERATOR) ((STREAM INPUT-STREAM)) :PUBLIC? TRUE)"
    (CL:FUNCTION LINES) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD (NEXT? BOOLEAN) ((SELF LINE-ITERATOR)) :PUBLIC? TRUE)"
    (CL:FUNCTION NEXT?) NULL)
   (DEFINE-FUNCTION-OBJECT "CHARACTERS"
    "(DEFUN (CHARACTERS CHARACTER-ITERATOR) ((STREAM INPUT-STREAM)) :PUBLIC? TRUE)"
    (CL:FUNCTION CHARACTERS) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD (NEXT? BOOLEAN) ((SELF CHARACTER-ITERATOR)) :PUBLIC? TRUE)"
    (CL:FUNCTION NEXT?) NULL)
   (DEFINE-FUNCTION-OBJECT "STARTUP-STREAMS"
    "(DEFUN STARTUP-STREAMS () :PUBLIC? TRUE)" (CL:FUNCTION STARTUP-STREAMS)
    NULL)
   (CL:LET* ((FUNCTION (LOOKUP-FUNCTION SYM-STREAMS-STELLA-STARTUP-STREAMS)))
    (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS FUNCTION)
     SYM-STREAMS-STELLA-METHOD-STARTUP-CLASSNAME (WRAP-STRING "Startup-Streams")
     NULL-STRING-WRAPPER)))
  :VOID)

(CL:DEFUN STARTUP-STREAMS ()
  (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 0)
   (CL:LET* ((SELF-001 (NEW-OUTPUT-STREAM)))
    (CL:SETF (%NATIVE-STREAM SELF-001) CL:*STANDARD-OUTPUT*)
    (CL:SETQ STANDARD-OUTPUT SELF-001))
   (CL:WHEN (CL:EQ STANDARD-WARNING NULL)
    (CL:LET* ((SELF-002 (NEW-OUTPUT-STREAM)))
     (CL:SETF (%NATIVE-STREAM SELF-002) CL:*ERROR-OUTPUT*)
     (CL:SETQ STANDARD-WARNING SELF-002)))
   (CL:LET* ((SELF-003 (NEW-OUTPUT-STREAM)))
    (CL:SETF (%NATIVE-STREAM SELF-003) CL:*ERROR-OUTPUT*)
    (CL:SETQ STANDARD-ERROR SELF-003)))
  (CL:LET* ((*MODULE* *STELLA-MODULE*) (*CONTEXT* *MODULE*))
   (CL:DECLARE (CL:SPECIAL *MODULE* *CONTEXT*))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 2) (HELP-STARTUP-STREAMS1)
    (HELP-STARTUP-STREAMS2))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 4) (CL:SETQ EOL SYM-STREAMS-STELLA-EOL)
    (CL:LET* ((SELF-000 (NEW-INPUT-STREAM)))
     (CL:SETF (%NATIVE-STREAM SELF-000) CL:*STANDARD-INPUT*)
     (CL:SETQ STANDARD-INPUT SELF-000))
    (CL:SETQ SINGLE-QUOTE-STRING (WRAP-STRING "'"))
    (CL:SETQ SINGLE-BQUOTE-STRING (WRAP-STRING "`"))
    (CL:SETQ *OPEN-FILE-STREAMS* (NEW-LIST))
    (CL:SETQ *HTML-ESCAPE-TABLE* (NEW-KEY-VALUE-LIST)))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 5)
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "STREAM-ITERATOR"
        "(DEFCLASS STREAM-ITERATOR (ABSTRACT-ITERATOR) :PUBLIC? TRUE :ABSTRACT? TRUE :DOCUMENTATION \"Iterator that yields tokens from an input stream.\" :SLOTS ((THE-STREAM :TYPE INPUT-STREAM)) :TERMINATOR TERMINATE-STREAM-ITERATOR?)")))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION ACCESS-STREAM-ITERATOR-SLOT-VALUE)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "S-EXPRESSION-ITERATOR"
        "(DEFCLASS S-EXPRESSION-ITERATOR (STREAM-ITERATOR) :PUBLIC? TRUE :DOCUMENTATION \"Iterator that yields s-expressions from an input stream.\" :PARAMETERS ((ANY-VALUE :TYPE OBJECT)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION NEW-S-EXPRESSION-ITERATOR)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "LINE-ITERATOR"
        "(DEFCLASS LINE-ITERATOR (STREAM-ITERATOR) :PUBLIC? TRUE :DOCUMENTATION \"Iterator that yields lines from an input stream.\" :PARAMETERS ((ANY-VALUE :TYPE STRING)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS) (CL:FUNCTION NEW-LINE-ITERATOR)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "CHARACTER-ITERATOR"
        "(DEFCLASS CHARACTER-ITERATOR (STREAM-ITERATOR) :PUBLIC? TRUE :DOCUMENTATION \"Iterator that yields characters from an input stream.\" :PARAMETERS ((ANY-VALUE :TYPE CHARACTER)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION NEW-CHARACTER-ITERATOR))))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 6) (FINALIZE-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 7) (HELP-STARTUP-STREAMS3))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 8) (FINALIZE-SLOTS)
    (CLEANUP-UNFINALIZED-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 9)
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL EOL SYMBOL (QUOTE EOL) :DOCUMENTATION \"Generates a newline character when passed to a stream.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL EOL-STRING STRING \"
\" :DOCUMENTATION \"A string constant containing the character sequence
necessary to generate a newline.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL STANDARD-INPUT INPUT-STREAM NULL :DOCUMENTATION \"Denotes the standard input stream for the host language.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL STANDARD-OUTPUT OUTPUT-STREAM NULL :DOCUMENTATION \"Denotes the standard output stream for the host language.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL STANDARD-WARNING OUTPUT-STREAM NULL :DOCUMENTATION \"Denotes the standard warning stream for the host language.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL STANDARD-ERROR OUTPUT-STREAM NULL :DOCUMENTATION \"Denotes the standard error stream for the host language.\" :PUBLIC? TRUE)")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL SINGLE-QUOTE-STRING STRING-WRAPPER (WRAP-LITERAL \"'\") :DOCUMENTATION \"Holds a string containing the single quote character.\")")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL SINGLE-BQUOTE-STRING STRING-WRAPPER (WRAP-LITERAL \"`\") :DOCUMENTATION \"Holds a string containing the single backquote character.\")")
    (STORE-MACRO SYM-STREAMS-STELLA-PRINT SYM-STREAMS-STELLA-PRINT-EXPANDER
     (CL:FUNCTION PRINT-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-INFORM SYM-STREAMS-STELLA-INFORM-EXPANDER
     (CL:FUNCTION INFORM-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WARN SYM-STREAMS-STELLA-WARN-EXPANDER
     (CL:FUNCTION WARN-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-SIGNAL SYM-STREAMS-STELLA-SIGNAL-EXPANDER
     (CL:FUNCTION SIGNAL-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-ERROR SYM-STREAMS-STELLA-ERROR-EXPANDER
     (CL:FUNCTION ERROR-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-CONTINUABLE-ERROR
     SYM-STREAMS-STELLA-CONTINUABLE-ERROR-EXPANDER
     (CL:FUNCTION CONTINUABLE-ERROR-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-SIGNAL-READ-ERROR
     SYM-STREAMS-STELLA-SIGNAL-READ-ERROR-EXPANDER
     (CL:FUNCTION SIGNAL-READ-ERROR-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WALK-ERROR
     SYM-STREAMS-STELLA-WALK-ERROR-EXPANDER (CL:FUNCTION WALK-ERROR-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WALK-INFORM
     SYM-STREAMS-STELLA-WALK-INFORM-EXPANDER (CL:FUNCTION WALK-INFORM-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WALK-WARN
     SYM-STREAMS-STELLA-WALK-WARN-EXPANDER (CL:FUNCTION WALK-WARN-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-SAFETY SYM-STREAMS-STELLA-SAFETY-EXPANDER
     (CL:FUNCTION SAFETY-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-EVALUATION-ERROR
     SYM-STREAMS-STELLA-EVALUATION-ERROR-EXPANDER
     (CL:FUNCTION EVALUATION-ERROR-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-MESSAGE-TO-STRING
     SYM-STREAMS-STELLA-MESSAGE-TO-STRING-EXPANDER
     (CL:FUNCTION MESSAGE-TO-STRING-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WITH-HTML-TAG
     SYM-STREAMS-STELLA-WITH-HTML-TAG-EXPANDER
     (CL:FUNCTION WITH-HTML-TAG-EXPANDER))
    (STORE-MACRO SYM-STREAMS-STELLA-WITH-XML-TAG
     SYM-STREAMS-STELLA-WITH-XML-TAG-EXPANDER
     (CL:FUNCTION WITH-XML-TAG-EXPANDER))
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL *OPEN-FILE-STREAMS* (LIST OF STREAM) (NEW (LIST OF STREAM)) :DOCUMENTATION \"List of file streams that are currently open.\")")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL *HTML-QUOTED-CHARACTERS* STRING \"><&\\\"\")")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFGLOBAL *HTML-ESCAPE-TABLE* KEY-VALUE-LIST (NEW KEY-VALUE-LIST))")
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "lt") (WRAP-CHARACTER #\<))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "gt") (WRAP-CHARACTER #\>))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "amp") (WRAP-CHARACTER #\&))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "quot") (WRAP-CHARACTER #\"))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "apos") (WRAP-CHARACTER #\'))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "nbsp") (WRAP-CHARACTER #\ ))
    (INSERT-AT *HTML-ESCAPE-TABLE* (WRAP-STRING "NBSP") (WRAP-CHARACTER #\ ))))
  :VOID)
